package com.offcn.api.nwn.ht;



import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;

import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 45. 母版信息编辑
 * 
 * @author liyy
 *
 */
public class editTemp extends NWN implements API {
	
	public String parameter;//参数集合
	
	public String id;//母板ID
//	public String phone;//层级包id
	@Override
	public void initialize(HashMap<String, Object> data) {
		try {
			String sql="SELECT  MAX(id) AS id  FROM  n_template  ";
			//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
			ResultSet rs_bankcard = this.sqlFromDB(sql);
			rs_bankcard.last();
			id =  rs_bankcard.getString("id");
			System.out.println("db_templateid============"+ rs_bankcard.getString("id"));
			
		} catch (Exception e) {
			
			e.printStackTrace();
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		id = MapUtil.getParameter(parameter, "id").trim();
		
		
		if ((!id.equals("")) && id.equals("template_id")) {
			id=template_id;
			parameter = parameter.replace("\"id\":template_id", "\"id\":" +  id );
			
			
		}
		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
//		Map<String,String> m=new HashMap<String,String>();
//		m.put("user_info", parameter);
		//Response re = RequestDataUtils.Post_cooike_form_data(data, Url,"PHPSESSID",PHPSESSID,m);	
		Response re = RequestDataUtils.Post_cooike(data, Url, "PHPSESSID",PHPSESSID);
		//Response re = RequestDataUtils.Get_one_cookie(data, serviceURL, cookie1Name, cookie1value)   //只能无参
//		Response re = RequestDataUtils.Get_token(data, Url, "");
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		System.out.println( "jp===="+ jp);
		boolean result = true;
		String failReason = "";

		String json = re.asString();
		System.out.println("response=========="+json);

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					System.out.println(strCustomStrings.length);
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
						
			if("0".equals(code)){
				
			
			
			}
			
			
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
