package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.io.UnsupportedEncodingException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.HttpRequest;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.api.nwn.md5.nwngetsign;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

/**
 * 添加学员信息
 * 
 * @author liyy
 * 
 */
public class addCosId extends NWN implements API {

	public String parameter;// 参数集合
	public String template_id_1;
	public String cos_id;//


	@Override
	public void initialize(HashMap<String, Object> data) {
	
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		cos_id = MapUtil.getParameter(parameter, "cos_id").trim();
		template_id_1 = MapUtil.getParameter(parameter, "template_id").trim();
				
		if ((!template_id_1.equals("")) && template_id_1.equals("template_id")) {
					
			parameter = parameter.replace("\"template_id\":template_id", "\"template_id\":\""+ template_id + "\"");
		}
		if ((!cos_id.equals("")) && cos_id.equals("cos_id")) {
			cos_id="1"+(new Random().nextInt(1000));
			parameter = parameter.replace("\"cos_id\":cos_id", "\"cos_id\":\""+ cos_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}


	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = new JsonPath(re.asString());
		System.out.println("jp====" + jp);
		boolean result = true;
		String failReason = "";

		String json = re.asString();
		
		json = StringUtils.decodeUnicode(json);
		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {

			if (!json.contains(data.get("msg").toString())) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("message") + ".";
			}

			if (data.get("custom") != null && json != null) {
				// 如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if (data.get("custom").toString().contains(",")) {
					String[] strCustomStrings = data.get("custom").toString()
							.split(",");
					System.out.println(strCustomStrings.length);
					for (int i = 0; i < strCustomStrings.length; i++) {
						if (!json.contains(strCustomStrings[i])) {
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString()
									+ " but actually " + strCustomStrings[i]
									+ ".";
							break;
						}
					}
				} else {// 如果只有一个希望结果，就直接包含比较。
					if (!json.contains(data.get("custom").toString())) {
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString()
								+ " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}

	if("0".equals(jp.getString("retcode"))){
				
				//是否验证数据库
					
				if (!isProduct) {
					
				}
		}
	}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	
		}
	}